Index: /CKEditor/branches/versions/3.2.x/_source/core/editor.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/core/editor.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/core/editor.js	(revision 5134)
@@ -122,4 +122,6 @@
 		editor.skinPath = skinPath;
 		editor.skinClass = 'cke_skin_' + skinName;
+
+		editor.tabIndex = editor.config.tabIndex || editor.element.getAttribute( 'tabindex' ) || 0;
 
 		// Fire the "configLoaded" event.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/_translationstatus.txt
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/_translationstatus.txt	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/_translationstatus.txt	(revision 5134)
@@ -2,59 +2,59 @@
 For licensing, see LICENSE.html or http://ckeditor.com/license
 
-af.js      Found: 302 Missing: 194
-ar.js      Found: 466 Missing: 30
-bg.js      Found: 295 Missing: 201
-bn.js      Found: 297 Missing: 199
-bs.js      Found: 203 Missing: 293
-ca.js      Found: 419 Missing: 77
-cs.js      Found: 426 Missing: 70
-cy.js      Found: 467 Missing: 29
-da.js      Found: 419 Missing: 77
-de.js      Found: 459 Missing: 37
-el.js      Found: 301 Missing: 195
-en-au.js   Found: 384 Missing: 112
-en-ca.js   Found: 384 Missing: 112
-en-gb.js   Found: 384 Missing: 112
-eo.js      Found: 275 Missing: 221
-es.js      Found: 476 Missing: 20
-et.js      Found: 316 Missing: 180
-eu.js      Found: 419 Missing: 77
-fa.js      Found: 317 Missing: 179
-fi.js      Found: 482 Missing: 14
-fo.js      Found: 316 Missing: 180
-fr-ca.js   Found: 317 Missing: 179
-fr.js      Found: 418 Missing: 78
-gl.js      Found: 298 Missing: 198
-gu.js      Found: 316 Missing: 180
-he.js      Found: 482 Missing: 14
-hi.js      Found: 317 Missing: 179
-hr.js      Found: 419 Missing: 77
-hu.js      Found: 316 Missing: 180
-is.js      Found: 322 Missing: 174
-it.js      Found: 419 Missing: 77
-ja.js      Found: 428 Missing: 68
-km.js      Found: 291 Missing: 205
-ko.js      Found: 308 Missing: 188
-lt.js      Found: 321 Missing: 175
-lv.js      Found: 298 Missing: 198
-mn.js      Found: 316 Missing: 180
-ms.js      Found: 280 Missing: 216
-nb.js      Found: 425 Missing: 71
-nl.js      Found: 482 Missing: 14
-no.js      Found: 425 Missing: 71
-pl.js      Found: 426 Missing: 70
-pt-br.js   Found: 418 Missing: 78
-pt.js      Found: 297 Missing: 199
-ro.js      Found: 316 Missing: 180
-ru.js      Found: 482 Missing: 14
-sk.js      Found: 317 Missing: 179
-sl.js      Found: 425 Missing: 71
-sr-latn.js Found: 291 Missing: 205
-sr.js      Found: 291 Missing: 205
-sv.js      Found: 314 Missing: 182
-th.js      Found: 302 Missing: 194
-tr.js      Found: 322 Missing: 174
-uk.js      Found: 419 Missing: 77
-vi.js      Found: 419 Missing: 77
-zh-cn.js   Found: 419 Missing: 77
-zh.js      Found: 419 Missing: 77
+af.js      Found: 302 Missing: 196
+ar.js      Found: 466 Missing: 32
+bg.js      Found: 295 Missing: 203
+bn.js      Found: 297 Missing: 201
+bs.js      Found: 203 Missing: 295
+ca.js      Found: 419 Missing: 79
+cs.js      Found: 426 Missing: 72
+cy.js      Found: 467 Missing: 31
+da.js      Found: 419 Missing: 79
+de.js      Found: 459 Missing: 39
+el.js      Found: 301 Missing: 197
+en-au.js   Found: 384 Missing: 114
+en-ca.js   Found: 384 Missing: 114
+en-gb.js   Found: 384 Missing: 114
+eo.js      Found: 275 Missing: 223
+es.js      Found: 476 Missing: 22
+et.js      Found: 316 Missing: 182
+eu.js      Found: 419 Missing: 79
+fa.js      Found: 317 Missing: 181
+fi.js      Found: 482 Missing: 16
+fo.js      Found: 316 Missing: 182
+fr-ca.js   Found: 317 Missing: 181
+fr.js      Found: 418 Missing: 80
+gl.js      Found: 298 Missing: 200
+gu.js      Found: 316 Missing: 182
+he.js      Found: 482 Missing: 16
+hi.js      Found: 317 Missing: 181
+hr.js      Found: 419 Missing: 79
+hu.js      Found: 316 Missing: 182
+is.js      Found: 322 Missing: 176
+it.js      Found: 419 Missing: 79
+ja.js      Found: 428 Missing: 70
+km.js      Found: 291 Missing: 207
+ko.js      Found: 308 Missing: 190
+lt.js      Found: 321 Missing: 177
+lv.js      Found: 298 Missing: 200
+mn.js      Found: 316 Missing: 182
+ms.js      Found: 280 Missing: 218
+nb.js      Found: 425 Missing: 73
+nl.js      Found: 482 Missing: 16
+no.js      Found: 425 Missing: 73
+pl.js      Found: 426 Missing: 72
+pt-br.js   Found: 418 Missing: 80
+pt.js      Found: 297 Missing: 201
+ro.js      Found: 316 Missing: 182
+ru.js      Found: 482 Missing: 16
+sk.js      Found: 317 Missing: 181
+sl.js      Found: 425 Missing: 73
+sr-latn.js Found: 291 Missing: 207
+sr.js      Found: 291 Missing: 207
+sv.js      Found: 314 Missing: 184
+th.js      Found: 302 Missing: 196
+tr.js      Found: 322 Missing: 176
+uk.js      Found: 419 Missing: 79
+vi.js      Found: 419 Missing: 79
+zh-cn.js   Found: 419 Missing: 79
+zh.js      Found: 419 Missing: 79
Index: /CKEditor/branches/versions/3.2.x/_source/lang/af.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/af.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/af.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/ar.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/ar.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/ar.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/bg.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/bg.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/bg.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/bn.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/bn.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/bn.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/bs.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/bs.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/bs.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/ca.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/ca.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/ca.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/cs.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/cs.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/cs.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/cy.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/cy.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/cy.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/da.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/da.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/da.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/de.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/de.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/de.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/el.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/el.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/el.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/en-au.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/en-au.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/en-au.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/en-ca.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/en-ca.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/en-ca.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/en-gb.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/en-gb.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/en-gb.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/en.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/en.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/en.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.',
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar',
+	editor : 'Rich Text Editor',
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/eo.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/eo.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/eo.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/es.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/es.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/es.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/et.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/et.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/et.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/eu.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/eu.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/eu.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/fa.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/fa.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/fa.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/fi.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/fi.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/fi.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/fo.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/fo.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/fo.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/fr-ca.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/fr-ca.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/fr-ca.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/fr.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/fr.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/fr.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/gl.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/gl.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/gl.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/gu.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/gu.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/gu.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/he.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/he.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/he.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/hi.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/hi.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/hi.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/hr.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/hr.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/hr.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/hu.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/hu.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/hu.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/is.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/is.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/is.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/it.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/it.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/it.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/ja.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/ja.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/ja.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/km.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/km.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/km.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/ko.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/ko.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/ko.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/lt.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/lt.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/lt.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/lv.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/lv.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/lv.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/mn.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/mn.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/mn.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/ms.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/ms.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/ms.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/nb.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/nb.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/nb.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/nl.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/nl.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/nl.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/no.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/no.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/no.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/pl.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/pl.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/pl.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/pt-br.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/pt-br.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/pt-br.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/pt.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/pt.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/pt.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/ro.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/ro.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/ro.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/ru.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/ru.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/ru.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/sk.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/sk.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/sk.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/sl.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/sl.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/sl.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/sr-latn.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/sr-latn.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/sr-latn.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/sr.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/sr.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/sr.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/sv.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/sv.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/sv.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/th.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/th.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/th.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/tr.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/tr.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/tr.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/uk.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/uk.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/uk.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/vi.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/vi.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/vi.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/zh-cn.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/zh-cn.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/zh-cn.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/lang/zh.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/lang/zh.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/lang/zh.js	(revision 5134)
@@ -33,4 +33,8 @@
 	 */
 	editorTitle		: 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar : 'Toolbar', // MISSING
+	editor : 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
Index: /CKEditor/branches/versions/3.2.x/_source/plugins/a11yhelp/dialogs/a11yhelp.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/plugins/a11yhelp/dialogs/a11yhelp.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/plugins/a11yhelp/dialogs/a11yhelp.js	(revision 5134)
@@ -125,5 +125,5 @@
 	function buildHelpContents()
 	{
-		var pageTpl = '<div class="cke_accessibility_legend" role="document" tabIndex="-1">%1</div>',
+		var pageTpl = '<div class="cke_accessibility_legend" tabIndex="-1">%1</div>',
 			sectionTpl = '<h1>%1</h1><dl>%2</dl>',
 			itemTpl = '<dt>%1</dt><dd>%2</dd>';
Index: /CKEditor/branches/versions/3.2.x/_source/plugins/dialog/plugin.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/plugins/dialog/plugin.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/plugins/dialog/plugin.js	(revision 5134)
@@ -128,21 +128,13 @@
 		this.parts = themeBuilt.parts;
 
-		var dialogPart = this.parts.dialog,
-			 titleId = this.parts.title.$.id;
-
-		dialogPart.setAttributes(
-			{
-				'role' : 'dialog',
-				'aria-labelledby' : titleId
-			});
-
 		CKEDITOR.tools.setTimeout( function()
 			{
 				editor.fire( 'ariaWidget', this.parts.contents );
-			}, 0, this );
+			},
+			0, this );
 		
 		// Set the startup styles for the dialog, avoiding it enlarging the
 		// page size on the dialog creation.
-		dialogPart.setStyles(
+		this.parts.dialog.setStyles(
 			{
 				position : CKEDITOR.env.ie6Compat ? 'absolute' : 'fixed',
@@ -151,6 +143,4 @@
 				visibility : 'hidden'
 			});
-
-		this.parts.tabs.setAttribute( 'role', 'tablist' );
 
 		// Call the CKEDITOR.event constructor to initialize this instance.
@@ -897,11 +887,12 @@
 						' tabIndex="-1"',
 						' hidefocus="true"',
+						' aria-labelledby="', tabId, '_arialbl"',
 						' role="tab">',
-							contents.label,
+							'<span id="', tabId, '_arialbl">',
+								contents.label,
+							'</span>',
 					'</a>'
 				].join( '' ) );
 			
-			page.setAttribute( 'aria-labelledby', tabId );
-
 			// If only a single page exist, a different style is used in the central pane.
 			if ( this._.pageCount === 0 )
@@ -2170,5 +2161,5 @@
 						if ( i == childHtmlList.length - 1 )
 							className = 'cke_dialog_ui_hbox_last';
-						html.push( '<td class="', className, '" ' );
+						html.push( '<td class="', className, '" role="presentation" ' );
 						if ( widths )
 						{
@@ -2190,4 +2181,7 @@
 				};
 
+				var attribs = { role : 'presentation' };
+				elementDefinition && elementDefinition.align && ( attribs.align = elementDefinition.align );
+
 				CKEDITOR.ui.dialog.uiElement.call(
 					this,
@@ -2197,5 +2191,5 @@
 					'table',
 					styles,
-					elementDefinition && elementDefinition.align && { align : elementDefinition.align } || null,
+					attribs,
 					innerHTML );
 			},
@@ -2242,5 +2236,5 @@
 				var innerHTML = function()
 				{
-					var html = [ '<table cellspacing="0" border="0" ' ];
+					var html = [ '<table role="presentation" cellspacing="0" border="0" ' ];
 					html.push( 'style="' );
 					if ( elementDefinition && elementDefinition.expand )
@@ -2255,5 +2249,5 @@
 					{
 						var styles = [];
-						html.push( '<tr><td ' );
+						html.push( '<tr><td role="presentation" ' );
 						if ( width )
 							styles.push( 'width:' + CKEDITOR.tools.cssLength( width || '100%' ) );
@@ -2271,5 +2265,5 @@
 					return html.join( '' );
 				};
-				CKEDITOR.ui.dialog.uiElement.call( this, dialog, elementDefinition || { type : 'vbox' }, htmlList, 'div', null, null, innerHTML );
+				CKEDITOR.ui.dialog.uiElement.call( this, dialog, elementDefinition || { type : 'vbox' }, htmlList, 'div', null, { role : 'presentation' }, innerHTML );
 			}
 		};
Index: /CKEditor/branches/versions/3.2.x/_source/plugins/dialogui/plugin.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/plugins/dialogui/plugin.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/plugins/dialogui/plugin.js	(revision 5134)
@@ -154,5 +154,5 @@
 								elementDefinition.label,
 								'</label>',
-								'<div class="cke_dialog_ui_labeled_content">',
+								'<div class="cke_dialog_ui_labeled_content" role="presentation">',
 								contentHtml.call( this, dialog, elementDefinition ),
 								'</div>' );
@@ -186,5 +186,5 @@
 					return html.join( '' );
 				};
-				CKEDITOR.ui.dialog.uiElement.call( this, dialog, elementDefinition, htmlList, 'div', null, null, innerHTML );
+				CKEDITOR.ui.dialog.uiElement.call( this, dialog, elementDefinition, htmlList, 'div', null, { role : 'presentation' }, innerHTML );
 			},
 
@@ -259,5 +259,5 @@
 					// IE BUG: Text input fields in IE at 100% would exceed a <td> or inline
 					// container's width, so need to wrap it inside a <div>.
-					var html = [ '<div class="cke_dialog_ui_input_', elementDefinition.type, '"' ];
+					var html = [ '<div class="cke_dialog_ui_input_', elementDefinition.type, '" role="presentation"' ];
 
 					if ( elementDefinition.width )
@@ -318,5 +318,5 @@
 					attributes[ 'aria-labelledby' ] = this._.labelId;
 					this._.required && ( attributes[ 'aria-required' ] = this._.required );
-					var html = [ '<div class="cke_dialog_ui_input_textarea"><textarea class="cke_dialog_ui_input_textarea" id="', domId, '" ' ];
+					var html = [ '<div class="cke_dialog_ui_input_textarea" role="presentation"><textarea class="cke_dialog_ui_input_textarea" id="', domId, '" ' ];
 					for ( var i in attributes )
 						html.push( i + '="' + CKEDITOR.tools.htmlEncode( attributes[i] ) + '" ' );
Index: /CKEditor/branches/versions/3.2.x/_source/plugins/editingblock/plugin.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/plugins/editingblock/plugin.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/plugins/editingblock/plugin.js	(revision 5134)
@@ -96,11 +96,11 @@
 					event.removeListener();
 
-					// Grab editor focus if the editor container is focused. (#3104)
-					var focusGrabber = editor.container;
-
 					// Safari 3 can't handle tabindex in all elements, so we do
 					// a trick to make it move the focus to the editor on TAB.
 					if ( CKEDITOR.env.webkit && CKEDITOR.env.version < 528 )
 					{
+						// Grab editor focus if the editor container is focused. (#3104)
+						var focusGrabber = editor.container;
+
 						var tabIndex = editor.config.tabIndex || editor.element.getAttribute( 'tabindex' ) || 0;
 						focusGrabber = focusGrabber.append( CKEDITOR.dom.element.createFromHtml(
@@ -108,10 +108,10 @@
 								' tabindex="' + tabIndex + '"' +
 								' style="position:absolute; left:-10000">' ) );
+
+						focusGrabber.on( 'focus', function()
+							{
+								editor.focus();
+							});
 					}
-
-					focusGrabber.on( 'focus', function()
-						{
-							editor.focus();
-						});
 
 					if ( editor.config.startupFocus )
Index: /CKEditor/branches/versions/3.2.x/_source/plugins/elementspath/plugin.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/plugins/elementspath/plugin.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/plugins/elementspath/plugin.js	(revision 5134)
@@ -50,5 +50,9 @@
 				{
 					if ( event.data.space == 'bottom' )
-						event.data.html += '<div id="' + spaceId + '" class="cke_path">' + emptyHtml + '</div>';
+					{
+						event.data.html += 
+							'<span id="' + spaceId + '_label" class="cke_voice_label">' + editor.lang.elementsPath.eleLabel + '</span>' +
+							'<div id="' + spaceId + '" class="cke_path" role="group" aria-labelledby="' + spaceId + '_label">' + emptyHtml + '</div>';
+					}
 				});
 
Index: /CKEditor/branches/versions/3.2.x/_source/plugins/menu/plugin.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/plugins/menu/plugin.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/plugins/menu/plugin.js	(revision 5134)
@@ -223,5 +223,5 @@
 
 				// Build the HTML that composes the menu and its items.
-				var output = [ '<div class="cke_menu">' ];
+				var output = [ '<div class="cke_menu" role="presentation">' ];
 
 				var length = items.length,
@@ -233,5 +233,5 @@
 					if ( lastGroup != item.group )
 					{
-						output.push( '<div class="cke_menuseparator"></div>' );
+						output.push( '<div class="cke_menuseparator" role="separator"></div>' );
 						lastGroup = item.group;
 					}
Index: /CKEditor/branches/versions/3.2.x/_source/plugins/panel/plugin.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/plugins/panel/plugin.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/plugins/panel/plugin.js	(revision 5134)
@@ -79,4 +79,5 @@
 			'<div class="', editor.skinClass ,'"' +
 				' lang="', editor.langCode, '"' +
+				' role="presentation"' +
 				// iframe loading need sometime, keep the panel hidden(#4186).
 				' style="display:none;z-index:' + ( editor.config.baseFloatZIndex + 1 ) + '">' +
@@ -84,4 +85,5 @@
 					' id=', id,
 					' dir=', editor.lang.dir,
+					' role="presentation"' +
 					' class="cke_panel cke_', editor.lang.dir );
 
@@ -264,5 +266,6 @@
 					{
 						'tabIndex' : -1,
-						'class' : 'cke_panel_block'
+						'class' : 'cke_panel_block',
+						'role' : 'presentation'
 					},
 					styles :
Index: /CKEditor/branches/versions/3.2.x/_source/plugins/sourcearea/plugin.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/plugins/sourcearea/plugin.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/plugins/sourcearea/plugin.js	(revision 5134)
@@ -35,5 +35,5 @@
 								{
 									dir : 'ltr',
-									tabIndex : -1,
+									tabIndex : editor.tabIndex,
 									'role' : 'textbox',
 									'aria-label' : editor.lang.editorTitle.replace( '%1', editor.name )
Index: /CKEditor/branches/versions/3.2.x/_source/plugins/tab/plugin.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/plugins/tab/plugin.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/plugins/tab/plugin.js	(revision 5134)
@@ -16,5 +16,5 @@
 			exec : function( editor )
 			{
-				editor.container.focusNext( true );
+				editor.container.focusNext( true, editor.tabIndex );
 			}
 		};
@@ -24,5 +24,5 @@
 			exec : function( editor )
 			{
-				editor.container.focusPrevious( true );
+				editor.container.focusPrevious( true, editor.tabIndex );
 			}
 		};
@@ -34,10 +34,5 @@
 		init : function( editor )
 		{
-			// Register the keystrokes.
-			var keystrokes = editor.keystrokeHandler.keystrokes;
-			keystrokes[ 9 /* TAB */ ] = 'tab';
-			keystrokes[ CKEDITOR.SHIFT + 9 /* TAB */ ] = 'shiftTab';
-
-			var tabSpaces = editor.config.tabSpaces,
+			var tabSpaces = editor.config.tabSpaces || 0,
 				tabText = '';
 
@@ -45,41 +40,35 @@
 				tabText += '\xa0';
 
-			// Register the "tab" and "shiftTab" commands.
-			editor.addCommand( 'tab', CKEDITOR.tools.extend(
-				{
-					exec : function( editor )
+			if ( tabText )
+			{
+				editor.on( 'key', function( ev )
 					{
-						// Fire the "tab" event, making it possible to
-						// customize the TAB key behavior on specific cases.
-						if ( !editor.fire( 'tab' ) )
+						if ( ev.data.keyCode == 9 )	// TAB
 						{
-							if ( tabText.length > 0 )
-								editor.insertHtml( tabText );
-							else
-							{
-								// All browsers jump to the next field on TAB,
-								// except Safari, so we have to do that manually
-								// here.
-								/// https://bugs.webkit.org/show_bug.cgi?id=20597
-								return editor.execCommand( 'blur' );
-							}
+							editor.insertHtml( tabText );
+							ev.cancel();
 						}
-
-						return true;
-					}
-				}, meta ) );
-
-			editor.addCommand( 'shiftTab', CKEDITOR.tools.extend(
-				{
-					exec : function( editor )
+					});
+			}
+
+			if ( CKEDITOR.env.webkit )
+			{
+				editor.on( 'key', function( ev )
 					{
-						// Fire the "tab" event, making it possible to
-						// customize the TAB key behavior on specific cases.
-						if ( !editor.fire( 'shiftTab' ) )
-							return editor.execCommand( 'blurBack' );
-
-						return true;
-					}
-				}, meta ) );
+						var keyCode = ev.data.keyCode;
+
+						if ( keyCode == 9 && !tabText )				// TAB
+						{
+							ev.cancel();
+							editor.execCommand( 'blur' );
+						}
+						
+						if ( keyCode == ( CKEDITOR.SHIFT + 9 ) )	// SHIFT+TAB
+						{
+							editor.execCommand( 'blurBack' );
+							ev.cancel();
+						}
+					});
+			}
 
 			editor.addCommand( 'blur', CKEDITOR.tools.extend( blurCommand, meta ) );
@@ -96,8 +85,8 @@
  * element.focusNext();
  */
-CKEDITOR.dom.element.prototype.focusNext = function( ignoreChildren )
+CKEDITOR.dom.element.prototype.focusNext = function( ignoreChildren, indexToUse )
 {
 	var $ = this.$,
-		curTabIndex = this.getTabIndex(),
+		curTabIndex = indexToUse || this.getTabIndex(),
 		passedCurrent, enteredCurrent,
 		elected, electedTabIndex,
@@ -184,8 +173,8 @@
  * element.focusPrevious();
  */
-CKEDITOR.dom.element.prototype.focusPrevious = function( ignoreChildren )
+CKEDITOR.dom.element.prototype.focusPrevious = function( ignoreChildren, indexToUse )
 {
 	var $ = this.$,
-		curTabIndex = this.getTabIndex(),
+		curTabIndex = indexToUse || this.getTabIndex(),
 		passedCurrent, enteredCurrent,
 		elected,
@@ -265,4 +254,5 @@
  * hitting the TAB key. If set to zero, the TAB key will be used to move the
  * cursor focus to the next element in the page, out of the editor focus.
+ * @name CKEDITOR.config.tabSpaces
  * @type Number
  * @default 0
@@ -270,3 +260,2 @@
  * config.tabSpaces = 4;
  */
-CKEDITOR.config.tabSpaces = 0 ;
Index: /CKEditor/branches/versions/3.2.x/_source/plugins/toolbar/plugin.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/plugins/toolbar/plugin.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/plugins/toolbar/plugin.js	(revision 5134)
@@ -157,9 +157,14 @@
 						editor.toolbox = new toolbox();
 
-						var output = [ '<div class="cke_toolbox" role="toolbar"' ],
+						var labelId = 'cke_' + CKEDITOR.tools.getNextNumber();
+
+						var output = [ '<div class="cke_toolbox" role="toolbar" aria-labelledby="', labelId, '"' ],
 							expanded =  editor.config.toolbarStartupExpanded !== false,
 							groupStarted;
 
 						output.push( expanded ? '>' : ' style="display:none">' );
+
+						// Sends the ARIA label.
+						output.push( '<span id="', labelId, '" class="cke_voice_label">', editor.lang.toolbar, '</span>' );
 
 						var toolbars = editor.toolbox.toolbars,
@@ -197,5 +202,5 @@
 							}
 
-							output.push( '<span id="', toolbarId, '" class="cke_toolbar"><span class="cke_toolbar_start"></span>' );
+							output.push( '<span id="', toolbarId, '" class="cke_toolbar" role="presentation"><span class="cke_toolbar_start"></span>' );
 
 							// Add the toolbar to the "editor.toolbox.toolbars"
@@ -227,5 +232,5 @@
 										if ( !groupStarted )
 										{
-											output.push( '<span class="cke_toolgroup">' );
+											output.push( '<span class="cke_toolgroup" role="presentation">' );
 											groupStarted = 1;
 										}
Index: /CKEditor/branches/versions/3.2.x/_source/plugins/wysiwygarea/plugin.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/plugins/wysiwygarea/plugin.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/plugins/wysiwygarea/plugin.js	(revision 5134)
@@ -276,9 +276,6 @@
 								'document.close();' +
 								'})())"' : '' ) +
-  							' tabIndex="-1"' +
+  							' tabIndex="' + editor.tabIndex + '"' +
   							' allowTransparency="true"' +
-							' role="editbox"' +
-							' aria-multiline="true"' +
-							' aria-label="' + frameLabel + '"' +
   							'></iframe>' );
 
@@ -286,16 +283,24 @@
 						// will fill it with content and set custom domain.
 						iframe.on( 'load', function( e )
-						{
-							e.removeListener();
-							var doc = iframe.getFrameDocument().$;
-
-							// Custom domain handling is needed after each document.open().
-							doc.open();
-							if ( isCustomDomain )
-								doc.domain = document.domain;
-							doc.write( data );
-							doc.close();
-
-						} );
+							{
+								e.removeListener();
+								var doc = iframe.getFrameDocument().$;
+
+								// Custom domain handling is needed after each document.open().
+								doc.open();
+								if ( isCustomDomain )
+									doc.domain = document.domain;
+								doc.write( data );
+								doc.close();
+
+							});
+
+						// Firefox will not move the focus to the iframe, but
+						// to it's contents directly. We need to force it in
+						// other browsers instead.
+						iframe.on( 'focus', function()
+							{
+								editor.focus();
+							});
 
 						mainElement.append( iframe );
@@ -744,5 +749,5 @@
 					ieFocusGrabber = editor.container.append( CKEDITOR.dom.element.createFromHtml(
 						// Use 'span' instead of anything else to fly under the screen-reader radar. (#5049)
-						'<span tabindex="-1" style="position:absolute; left:-10000"></span>' ) );
+						'<span tabindex="-1" style="position:absolute; left:-10000" role="presentation"></span>' ) );
 
 					ieFocusGrabber.on( 'focus', function()
Index: /CKEditor/branches/versions/3.2.x/_source/themes/default/theme.js
===================================================================
--- /CKEditor/branches/versions/3.2.x/_source/themes/default/theme.js	(revision 5133)
+++ /CKEditor/branches/versions/3.2.x/_source/themes/default/theme.js	(revision 5134)
@@ -119,14 +119,15 @@
 					' title="', ( CKEDITOR.env.gecko ? ' ' : '' ), '"' +
 					' lang="', editor.langCode, '"' +
-					' tabindex="' + tabIndex + '"' +
 					' role="application"' +
+					' aria-labelledby="cke_', name, '_arialbl"' +
 					( style ? ' style="' + style + '"' : '' ) +
 					'>' +
-					'<span class="' , CKEDITOR.env.cssClass, '">' +
-						'<span class="cke_wrapper cke_', editor.lang.dir, '">' +
-							'<table class="cke_editor" border="0" cellspacing="0" cellpadding="0"><tbody>' +
-								'<tr', topHtml		? '' : ' style="display:none"', '><td id="cke_top_'		, name, '" class="cke_top">'	, topHtml		, '</td></tr>' +
-								'<tr', contentsHtml	? '' : ' style="display:none"', '><td id="cke_contents_', name, '" class="cke_contents" style="height:', height, '">', contentsHtml, '</td></tr>' +
-								'<tr', bottomHtml	? '' : ' style="display:none"', '><td id="cke_bottom_'	, name, '" class="cke_bottom">'	, bottomHtml	, '</td></tr>' +
+					'<span id="cke_', name, '_arialbl" class="cke_voice_label">' + editor.lang.editor + '</span>' +
+					'<span class="' , CKEDITOR.env.cssClass, '" role="presentation">' +
+						'<span class="cke_wrapper cke_', editor.lang.dir, '" role="presentation">' +
+							'<table class="cke_editor" border="0" cellspacing="0" cellpadding="0" role="presentation"><tbody>' +
+								'<tr', topHtml		? '' : ' style="display:none"', '><td id="cke_top_'		, name, '" class="cke_top" role="presentation">'	, topHtml		, '</td></tr>' +
+								'<tr', contentsHtml	? '' : ' style="display:none"', '><td id="cke_contents_', name, '" class="cke_contents" style="height:', height, '" role="presentation">', contentsHtml, '</td></tr>' +
+								'<tr', bottomHtml	? '' : ' style="display:none"', '><td id="cke_bottom_'	, name, '" class="cke_bottom" role="presentation">'	, bottomHtml	, '</td></tr>' +
 							'</tbody></table>' +
 							//Hide the container when loading skins, later restored by skin css.
@@ -136,6 +137,6 @@
 				'</span>' ].join( '' ) );
 
-			container.getChild( [0, 0, 0, 0, 0] ).unselectable();
-			container.getChild( [0, 0, 0, 0, 2] ).unselectable();
+			container.getChild( [1, 0, 0, 0, 0] ).unselectable();
+			container.getChild( [1, 0, 0, 0, 2] ).unselectable();
 
 			if ( elementMode == CKEDITOR.ELEMENT_MODE_REPLACE )
@@ -169,17 +170,18 @@
 						'" dir="', editor.lang.dir, '"' +
 						' lang="', editor.langCode, '"' +
-						' role="application"' +
+						' role="dialog"' +
+						' aria-labelledby="%title#"' +
 						'>' +
 						'<table class="cke_dialog', ' ' + CKEDITOR.env.cssClass,
-							' cke_', editor.lang.dir, '" style="position:absolute">' +
-							'<tr><td>' +
-							'<div class="%body">' +
-								'<div id="%title#" class="%title"></div>' +
-								'<a id="%close_button#" class="%close_button" href="javascript:void(0)" title="' +  editor.lang.common.close+'"><span class="cke_label">X</span></a>' +
-								'<div id="%tabs#" class="%tabs"></div>' +
-								  '<table class="%contents"><tr>' +
-								  '<td id="%contents#" class="%contents"></td>' +
-								  '</tr></table>' +
-								'<div id="%footer#" class="%footer"></div>' +
+							' cke_', editor.lang.dir, '" style="position:absolute" role="presentation">' +
+							'<tr><td role="presentation">' +
+							'<div class="%body" role="presentation">' +
+								'<div id="%title#" class="%title" role="presentation"></div>' +
+								'<a id="%close_button#" class="%close_button" href="javascript:void(0)" title="' +  editor.lang.common.close+'" role="button"><span class="cke_label">X</span></a>' +
+								'<div id="%tabs#" class="%tabs" role="tablist" aria-labelledby="%tabs#_arialbl"><span id="%tabs#_arialbl" class="cke_voice_label">Dialog Tabs</span></div>' +
+								'<table class="%contents" role="presentation"><tr>' +
+								  '<td id="%contents#" class="%contents" role="presentation"></td>' +
+								'</tr></table>' +
+								'<div id="%footer#" class="%footer" role="presentation"></div>' +
 							'</div>' +
 							'<div id="%tl#" class="%tl"></div>' +
